Git 2.13.2
[git/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
3c8f12c9
JH
18# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
85176d72
FC
26else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
30fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
2006f0ad
RR
39################################################################
40# It appears that people try to run tests without building...
41"$GIT_BUILD_DIR/git" >/dev/null
42if test $? != 1
43then
44 echo >&2 'error: you do not seem to have built git yet.'
45 exit 1
46fi
47
3c8f12c9
JH
48. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
49export PERL_PATH SHELL_PATH
50
4cde519f
RR
51# if --tee was passed, write the output not only to the terminal, but
52# additionally to the file test-results/$BASENAME.out, too.
53case "$GIT_TEST_TEE_STARTED, $* " in
54done,*)
55 # do not redirect again
56 ;;
452320f1 57*' --tee '*|*' --va'*|*' --verbose-log '*)
2d14e13c
JK
58 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
59 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
452320f1
JK
60
61 # Make this filename available to the sub-process in case it is using
62 # --verbose-log.
63 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
64 export GIT_TEST_TEE_OUTPUT_FILE
65
66 # Truncate before calling "tee -a" to get rid of the results
67 # from any previous runs.
68 >"$GIT_TEST_TEE_OUTPUT_FILE"
69
4cde519f 70 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
452320f1 71 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
925bdc92 72 test "$(cat "$BASE.exit")" = 0
4cde519f
RR
73 exit
74 ;;
75esac
76
e1970ce4 77# For repeatability, reset the environment to known value.
d5c1b7c2 78# TERM is sanitized below, after saving color control sequences.
e1970ce4 79LANG=C
899460f3 80LC_ALL=C
d9bdd39e 81PAGER=cat
e1970ce4 82TZ=UTC
d5c1b7c2 83export LANG LC_ALL PAGER TZ
8ff99e74 84EDITOR=:
661bfd13
SL
85# A call to "unset" with no arguments causes at least Solaris 10
86# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
87# deriving from the command substitution clustered with the other
88# ones.
3c8f12c9 89unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 90 my @env = keys %ENV;
730477f1
JL
91 my $ok = join("|", qw(
92 TRACE
93 DEBUG
94 USE_LOOKUP
95 TEST
96 .*_TEST
97 PROVE
98 VALGRIND
ac001282 99 UNZIP
edb54081 100 PERF_
e2a0ccc0 101 CURL_VERBOSE
4527aa10 102 TRACE_CURL
730477f1
JL
103 ));
104 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
105 print join("\n", @vars);
106')
5adf84eb 107unset XDG_CONFIG_HOME
8bade1e1 108unset GITPERLLIB
29e55cd5
JH
109GIT_AUTHOR_EMAIL=author@example.com
110GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
111GIT_COMMITTER_EMAIL=committer@example.com
112GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 113GIT_MERGE_VERBOSITY=5
f8246281
JH
114GIT_MERGE_AUTOEDIT=no
115export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
116export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
117export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 118export EDITOR
e1970ce4 119
124647c4
KB
120# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
121GIT_TRACE_BARE=1
122export GIT_TRACE_BARE
123
5d9fc888
TG
124if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
125then
126 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
127 export GIT_INDEX_VERSION
128fi
129
a731fa91
EP
130# Add libc MALLOC and MALLOC_PERTURB test
131# only if we are not executing the test with valgrind
1b3185fc 132if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 133 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
134then
135 setup_malloc_check () {
136 : nothing
137 }
138 teardown_malloc_check () {
139 : nothing
140 }
141else
142 setup_malloc_check () {
143 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
144 export MALLOC_CHECK_ MALLOC_PERTURB_
145 }
146 teardown_malloc_check () {
147 unset MALLOC_CHECK_ MALLOC_PERTURB_
148 }
149fi
a731fa91 150
b0f4c908
JK
151: ${ASAN_OPTIONS=detect_leaks=0}
152export ASAN_OPTIONS
153
886a3907
JH
154# Protect ourselves from common misconfiguration to export
155# CDPATH into the environment
156unset CDPATH
157
5565f47c 158unset GREP_OPTIONS
ac001282 159unset UNZIP
5565f47c 160
3d5c0cc9 161case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756 1621|2|true)
025232e8 163 GIT_TRACE=4
1c0cc756 164 ;;
6ce4e61f
CC
165esac
166
cd3c095c
JH
167# Convenience
168#
169# A regexp to match 5 and 40 hexdigits
170_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
171_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
172
3749fde5
JH
173# Zero SHA-1
174_z40=0000000000000000000000000000000000000000
175
f9e7d9f8 176EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
378932d3 177EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
f9e7d9f8 178
3f4ab627
JH
179# Line feed
180LF='
181'
182
a42643aa
JK
183# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
184# when case-folding filenames
185u200c=$(printf '\342\200\214')
186
378932d3 187export _x05 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
342e9ef2 188
e1970ce4
JH
189# Each test should start with something like this, after copyright notices:
190#
191# test_description='Description of this test...
192# This test checks if command xyzzy does the right thing...
193# '
194# . ./test-lib.sh
d5c1b7c2 195test "x$TERM" != "xdumb" && (
ca92a660
RH
196 test -t 1 &&
197 tput bold >/dev/null 2>&1 &&
198 tput setaf 1 >/dev/null 2>&1 &&
199 tput sgr0 >/dev/null 2>&1
200 ) &&
201 color=t
e1970ce4 202
e1970ce4
JH
203while test "$#" -ne 0
204do
205 case "$1" in
206 -d|--d|--de|--deb|--debu|--debug)
207 debug=t; shift ;;
886856ab
JH
208 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
209 immediate=t; shift ;;
5e2c08c6 210 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 211 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
0445e6f0
IB
212 -r)
213 shift; test "$#" -ne 0 || {
214 echo 'error: -r requires an argument' >&2;
215 exit 1;
216 }
217 run_list=$1; shift ;;
218 --run=*)
0ff74101 219 run_list=${1#--*=}; shift ;;
e1970ce4 220 -h|--h|--he|--hel|--help)
570f3226 221 help=t; shift ;;
e1970ce4
JH
222 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
223 verbose=t; shift ;;
ff09af3f 224 --verbose-only=*)
0ff74101 225 verbose_only=${1#--*=}
ff09af3f 226 shift ;;
1ece1274 227 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
228 # Ignore --quiet under a TAP::Harness. Saying how many tests
229 # passed without the ok/not ok details is always an error.
230 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
231 --with-dashes)
232 with_dashes=t; shift ;;
55db1df0 233 --no-color)
faa4bc35 234 color=; shift ;;
4e1be63c 235 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
236 valgrind=memcheck
237 shift ;;
238 --valgrind=*)
0ff74101 239 valgrind=${1#--*=}
952af351 240 shift ;;
5dfc368f 241 --valgrind-only=*)
0ff74101 242 valgrind_only=${1#--*=}
5dfc368f 243 shift ;;
44138559
JS
244 --tee)
245 shift ;; # was handled already
f423ef5f 246 --root=*)
0ff74101 247 root=${1#--*=}
f423ef5f 248 shift ;;
bb79af9d
JK
249 --chain-lint)
250 GIT_TEST_CHAIN_LINT=1
251 shift ;;
252 --no-chain-lint)
253 GIT_TEST_CHAIN_LINT=0
254 shift ;;
a136f6d8
JK
255 -x)
256 trace=t
257 verbose=t
258 shift ;;
452320f1
JK
259 --verbose-log)
260 verbose_log=t
261 shift ;;
e1970ce4 262 *)
1f729dca 263 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
264 esac
265done
266
26a07309 267if test -n "$valgrind_only"
5dfc368f
TR
268then
269 test -z "$valgrind" && valgrind=memcheck
270 test -z "$verbose" && verbose_only="$valgrind_only"
271elif test -n "$valgrind"
272then
273 verbose=t
274fi
952af351 275
ca92a660
RH
276if test -n "$color"
277then
d5c1b7c2
RH
278 # Save the color control sequences now rather than run tput
279 # each time say_color() is called. This is done for two
280 # reasons:
281 # * TERM will be changed to dumb
282 # * HOME will be changed to a temporary directory and tput
283 # might need to read ~/.terminfo from the original HOME
284 # directory to get the control sequences
285 # Note: This approach assumes the control sequences don't end
286 # in a newline for any terminal of interest (command
287 # substitutions strip trailing newlines). Given that most
288 # (all?) terminals in common use are related to ECMA-48, this
289 # shouldn't be a problem.
290 say_color_error=$(tput bold; tput setaf 1) # bold red
291 say_color_skip=$(tput setaf 4) # blue
292 say_color_warn=$(tput setaf 3) # brown/yellow
293 say_color_pass=$(tput setaf 2) # green
294 say_color_info=$(tput setaf 6) # cyan
295 say_color_reset=$(tput sgr0)
296 say_color_="" # no formatting for normal text
ca92a660 297 say_color () {
d5c1b7c2
RH
298 test -z "$1" && test -n "$quiet" && return
299 eval "say_color_color=\$say_color_$1"
ca92a660 300 shift
d5c1b7c2 301 printf "%s\\n" "$say_color_color$*$say_color_reset"
ca92a660
RH
302 }
303else
304 say_color() {
305 test -z "$1" && test -n "$quiet" && return
306 shift
307 printf "%s\n" "$*"
308 }
309fi
310
d5c1b7c2
RH
311TERM=dumb
312export TERM
313
55db1df0
PH
314error () {
315 say_color error "error: $*"
6e7b5aaf 316 GIT_EXIT_OK=t
55db1df0
PH
317 exit 1
318}
319
320say () {
321 say_color info "$*"
322}
323
614fe015
JK
324if test -n "$HARNESS_ACTIVE"
325then
326 if test "$verbose" = t || test -n "$verbose_only"
327 then
328 printf 'Bail out! %s\n' \
329 'verbose mode forbidden under TAP harness; try --verbose-log'
330 exit 1
331 fi
332fi
333
570f3226
MB
334test "${test_description}" != "" ||
335error "Test script did not set test_description."
336
337if test "$help" = "t"
338then
cb1aefda 339 printf '%s\n' "$test_description"
570f3226
MB
340 exit 0
341fi
342
4d9d62fa 343exec 5>&1
781f76b1 344exec 6<&0
4ecae3c8 345exec 7>&2
452320f1
JK
346if test "$verbose_log" = "t"
347then
348 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
349elif test "$verbose" = "t"
e1970ce4
JH
350then
351 exec 4>&2 3>&1
352else
353 exec 4>/dev/null 3>/dev/null
354fi
355
d88785e4
JK
356# Send any "-x" output directly to stderr to avoid polluting tests
357# which capture stderr. We can do this unconditionally since it
358# has no effect if tracing isn't turned on.
359#
360# Note that this sets up the trace fd as soon as we assign the variable, so it
361# must come after the creation of descriptor 4 above. Likewise, we must never
362# unset this, as it has the side effect of closing descriptor 4, which we
363# use to show verbose tests to the user.
364#
365# Note also that we don't need or want to export it. The tracing is local to
366# this shell, and we would not want to influence any shells we exec.
367BASH_XTRACEFD=4
368
e1970ce4
JH
369test_failure=0
370test_count=0
41ac414e
JH
371test_fixed=0
372test_broken=0
2d84e9fb 373test_success=0
e1970ce4 374
d998bd4a
ÆAB
375test_external_has_tap=0
376
faa4bc35 377die () {
6e7b5aaf
CB
378 code=$?
379 if test -n "$GIT_EXIT_OK"
380 then
381 exit $code
382 else
383 echo >&5 "FATAL: Unexpected exit with code $code"
384 exit 1
385 fi
faa4bc35
CB
386}
387
6e7b5aaf 388GIT_EXIT_OK=
35641310 389trap 'die' EXIT
da706545 390trap 'exit $?' INT
41184273 391
12a29b1a
TR
392# The user-facing functions are loaded from a separate file so that
393# test_perf subshells can have them too
3c8f12c9 394. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 395
886856ab 396# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 397# the test_expect_* functions instead.
886856ab
JH
398
399test_ok_ () {
d5d9de1b 400 test_success=$(($test_success + 1))
633fe50a 401 say_color "" "ok $test_count - $@"
e1970ce4
JH
402}
403
886856ab 404test_failure_ () {
d5d9de1b 405 test_failure=$(($test_failure + 1))
633fe50a 406 say_color error "not ok $test_count - $1"
bf0dd8a8 407 shift
cb1aefda 408 printf '%s\n' "$*" | sed -e 's/^/# /'
6e7b5aaf 409 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
410}
411
41ac414e 412test_known_broken_ok_ () {
41ac414e 413 test_fixed=$(($test_fixed+1))
633fe50a 414 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
415}
416
417test_known_broken_failure_ () {
41ac414e 418 test_broken=$(($test_broken+1))
633fe50a 419 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 420}
886856ab
JH
421
422test_debug () {
8e832ebc 423 test "$debug" = "" || eval "$1"
e1970ce4
JH
424}
425
e6a6ddc9
TR
426match_pattern_list () {
427 arg="$1"
428 shift
429 test -z "$*" && return 1
430 for pattern_
431 do
432 case "$arg" in
433 $pattern_)
434 return 0
435 esac
436 done
437 return 1
438}
439
0445e6f0
IB
440match_test_selector_list () {
441 title="$1"
442 shift
443 arg="$1"
444 shift
445 test -z "$1" && return 0
446
447 # Both commas and whitespace are accepted as separators.
448 OLDIFS=$IFS
449 IFS=' ,'
450 set -- $1
451 IFS=$OLDIFS
452
453 # If the first selector is negative we include by default.
454 include=
455 case "$1" in
456 !*) include=t ;;
457 esac
458
459 for selector
460 do
461 orig_selector=$selector
462
463 positive=t
464 case "$selector" in
465 !*)
466 positive=
467 selector=${selector##?}
468 ;;
469 esac
470
471 test -z "$selector" && continue
472
473 case "$selector" in
474 *-*)
475 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
476 then
477 echo "error: $title: invalid non-numeric in range" \
478 "start: '$orig_selector'" >&2
479 exit 1
480 fi
481 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
482 then
483 echo "error: $title: invalid non-numeric in range" \
484 "end: '$orig_selector'" >&2
485 exit 1
486 fi
487 ;;
488 *)
489 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
490 then
491 echo "error: $title: invalid non-numeric in test" \
492 "selector: '$orig_selector'" >&2
493 exit 1
494 fi
495 esac
496
497 # Short cut for "obvious" cases
498 test -z "$include" && test -z "$positive" && continue
499 test -n "$include" && test -n "$positive" && continue
500
501 case "$selector" in
502 -*)
503 if test $arg -le ${selector#-}
504 then
505 include=$positive
506 fi
507 ;;
508 *-)
509 if test $arg -ge ${selector%-}
510 then
511 include=$positive
512 fi
513 ;;
514 *-*)
515 if test ${selector%%-*} -le $arg \
516 && test $arg -le ${selector#*-}
517 then
518 include=$positive
519 fi
520 ;;
521 *)
522 if test $arg -eq $selector
523 then
524 include=$positive
525 fi
526 ;;
527 esac
528 done
529
530 test -n "$include"
531}
532
ff09af3f
TR
533maybe_teardown_verbose () {
534 test -z "$verbose_only" && return
535 exec 4>/dev/null 3>/dev/null
536 verbose=
537}
538
539last_verbose=t
540maybe_setup_verbose () {
541 test -z "$verbose_only" && return
26a07309 542 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
543 then
544 exec 4>&2 3>&1
545 # Emit a delimiting blank line when going from
546 # non-verbose to verbose. Within verbose mode the
547 # delimiter is printed by test_expect_*. The choice
548 # of the initial $last_verbose is such that before
549 # test 1, we do not print it.
550 test -z "$last_verbose" && echo >&3 ""
551 verbose=t
552 else
553 exec 4>/dev/null 3>/dev/null
554 verbose=
555 fi
556 last_verbose=$verbose
557}
558
5dfc368f
TR
559maybe_teardown_valgrind () {
560 test -z "$GIT_VALGRIND" && return
561 GIT_VALGRIND_ENABLED=
562}
563
564maybe_setup_valgrind () {
565 test -z "$GIT_VALGRIND" && return
26a07309 566 if test -z "$valgrind_only"
5dfc368f
TR
567 then
568 GIT_VALGRIND_ENABLED=t
569 return
570 fi
571 GIT_VALGRIND_ENABLED=
572 if match_pattern_list $test_count $valgrind_only
573 then
574 GIT_VALGRIND_ENABLED=t
575 fi
576}
577
9b5fe78b
JK
578want_trace () {
579 test "$trace" = t && test "$verbose" = t
580}
581
a136f6d8
JK
582# This is a separate function because some tests use
583# "return" to end a test_expect_success block early
584# (and we want to make sure we run any cleanup like
585# "set +x").
586test_eval_inner_ () {
587 # Do not add anything extra (including LF) after '$*'
588 eval "
9b5fe78b 589 want_trace && set -x
a136f6d8
JK
590 $*"
591}
592
a7c58f28 593test_eval_ () {
a136f6d8
JK
594 # We run this block with stderr redirected to avoid extra cruft
595 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
596 # the shell from printing the "set +x" to turn it off (nor the saving
597 # of $? before that). But we can make sure that the output goes to
598 # /dev/null.
599 #
600 # The test itself is run with stderr put back to &4 (so either to
601 # /dev/null, or to the original stderr if --verbose was used).
602 {
603 test_eval_inner_ "$@" </dev/null >&3 2>&4
604 test_eval_ret_=$?
9b5fe78b 605 if want_trace
a136f6d8
JK
606 then
607 set +x
608 if test "$test_eval_ret_" != 0
609 then
610 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
611 fi
612 fi
613 } 2>/dev/null
614 return $test_eval_ret_
a7c58f28
JN
615}
616
4d9d62fa 617test_run_ () {
b6b0afdc 618 test_cleanup=:
b586744a 619 expecting_failure=$2
bb79af9d 620
92b269f5 621 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
2a01ef8c
JK
622 # turn off tracing for this test-eval, as it simply creates
623 # confusing noise in the "-x" output
624 trace_tmp=$trace
625 trace=
bb79af9d
JK
626 # 117 is magic because it is unlikely to match the exit
627 # code of other programs
99a64e4b
JH
628 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
629 then
630 error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
bb79af9d 631 fi
2a01ef8c 632 trace=$trace_tmp
bb79af9d
JK
633 fi
634
a57397b0 635 setup_malloc_check
a7c58f28 636 test_eval_ "$1"
b6b0afdc 637 eval_ret=$?
a57397b0 638 teardown_malloc_check
b586744a 639
a136f6d8
JK
640 if test -z "$immediate" || test $eval_ret = 0 ||
641 test -n "$expecting_failure" && test "$test_cleanup" != ":"
b586744a 642 then
1b3185fc 643 setup_malloc_check
a7c58f28 644 test_eval_ "$test_cleanup"
1b3185fc 645 teardown_malloc_check
b586744a 646 fi
1c0cc756
RJ
647 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
648 then
57e1538a
ÆAB
649 echo ""
650 fi
aa0bcf96 651 return "$eval_ret"
4d9d62fa
PR
652}
653
ae75342c 654test_start_ () {
8586f98b 655 test_count=$(($test_count+1))
ff09af3f 656 maybe_setup_verbose
5dfc368f 657 maybe_setup_valgrind
ae75342c
TR
658}
659
660test_finish_ () {
661 echo >&3 ""
5dfc368f 662 maybe_teardown_valgrind
ff09af3f 663 maybe_teardown_verbose
ae75342c
TR
664}
665
666test_skip () {
04ece593 667 to_skip=
ef2ac68d 668 skipped_reason=
e6a6ddc9
TR
669 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
670 then
671 to_skip=t
ef2ac68d 672 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 673 fi
05236a5e
JN
674 if test -z "$to_skip" && test -n "$test_prereq" &&
675 ! test_have_prereq "$test_prereq"
a7bb3940
JS
676 then
677 to_skip=t
ef2ac68d 678
07431fc8 679 of_prereq=
05236a5e 680 if test "$missing_prereq" != "$test_prereq"
07431fc8 681 then
05236a5e 682 of_prereq=" of $test_prereq"
07431fc8 683 fi
ef2ac68d
IB
684 skipped_reason="missing $missing_prereq${of_prereq}"
685 fi
0445e6f0
IB
686 if test -z "$to_skip" && test -n "$run_list" &&
687 ! match_test_selector_list '--run' $test_count "$run_list"
688 then
689 to_skip=t
690 skipped_reason="--run"
691 fi
07431fc8 692
ef2ac68d
IB
693 case "$to_skip" in
694 t)
633fe50a 695 say_color skip >&3 "skipping test: $@"
ef2ac68d 696 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593
JH
697 : true
698 ;;
699 *)
700 false
701 ;;
702 esac
703}
704
342e9ef2
TR
705# stub; perf-lib overrides it
706test_at_end_hook_ () {
707 :
708}
709
e1970ce4 710test_done () {
6e7b5aaf 711 GIT_EXIT_OK=t
2d84e9fb 712
1c0cc756
RJ
713 if test -z "$HARNESS_ACTIVE"
714 then
342e9ef2 715 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 716 mkdir -p "$test_results_dir"
dd78478f 717 base=${0##*/}
5c885c1b 718 test_results_path="$test_results_dir/${base%.sh}.counts"
8ef1abe5 719
5c885c1b 720 cat >"$test_results_path" <<-EOF
c54e6be7
ML
721 total $test_count
722 success $test_success
723 fixed $test_fixed
724 broken $test_broken
725 failed $test_failure
726
727 EOF
8ef1abe5 728 fi
41ac414e
JH
729
730 if test "$test_fixed" != 0
731 then
633fe50a 732 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
733 fi
734 if test "$test_broken" != 0
735 then
633fe50a 736 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
737 fi
738 if test "$test_broken" != 0 || test "$test_fixed" != 0
739 then
740 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
741 msg="remaining $test_remaining test(s)"
11d54b8b 742 else
b73d9a23 743 test_remaining=$test_count
11d54b8b 744 msg="$test_count test(s)"
41ac414e 745 fi
e1970ce4 746 case "$test_failure" in
10b94e28 747 0)
1c0cc756
RJ
748 if test $test_external_has_tap -eq 0
749 then
b73d9a23 750 if test $test_remaining -gt 0
d87bd7c1 751 then
633fe50a 752 say_color pass "# passed all $msg"
d87bd7c1 753 fi
c7018be5
JH
754
755 # Maybe print SKIP message
756 test -z "$skip_all" || skip_all="# SKIP $skip_all"
757 case "$test_count" in
758 0)
759 say "1..$test_count${skip_all:+ $skip_all}"
760 ;;
761 *)
762 test -z "$skip_all" ||
763 say_color warn "$skip_all"
764 say "1..$test_count"
765 ;;
766 esac
d998bd4a 767 fi
abc5d372
JS
768
769 test -d "$remove_trash" &&
770 cd "$(dirname "$remove_trash")" &&
771 rm -rf "$(basename "$remove_trash")"
772
342e9ef2
TR
773 test_at_end_hook_
774
e1970ce4
JH
775 exit 0 ;;
776
777 *)
1c0cc756
RJ
778 if test $test_external_has_tap -eq 0
779 then
633fe50a
TR
780 say_color error "# failed $test_failure among $msg"
781 say "1..$test_count"
d998bd4a 782 fi
5099b99d 783
e1970ce4
JH
784 exit 1 ;;
785
786 esac
787}
788
e4597aae 789if test -n "$valgrind"
4e1be63c 790then
4e1be63c
JS
791 make_symlink () {
792 test -h "$2" &&
793 test "$1" = "$(readlink "$2")" || {
794 # be super paranoid
795 if mkdir "$2".lock
796 then
797 rm -f "$2" &&
798 ln -s "$1" "$2" &&
799 rm -r "$2".lock
800 else
801 while test -d "$2".lock
802 do
803 say "Waiting for lock on $2."
804 sleep 1
805 done
806 fi
807 }
808 }
809
810 make_valgrind_symlink () {
36bfb0e5 811 # handle only executables, unless they are shell libraries that
11d62145 812 # need to be in the exec-path.
36bfb0e5 813 test -x "$1" ||
11d62145 814 test "# " = "$(head -c 2 <"$1")" ||
36bfb0e5 815 return;
4e1be63c
JS
816
817 base=$(basename "$1")
28fab7b2
RS
818 case "$base" in
819 test-*)
820 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
821 ;;
822 *)
823 symlink_target="$GIT_BUILD_DIR/$base"
824 ;;
825 esac
4e1be63c
JS
826 # do not override scripts
827 if test -x "$symlink_target" &&
828 test ! -d "$symlink_target" &&
829 test "#!" != "$(head -c 2 < "$symlink_target")"
830 then
831 symlink_target=../valgrind.sh
832 fi
efd92ffd
JS
833 case "$base" in
834 *.sh|*.perl)
835 symlink_target=../unprocessed-script
836 esac
4e1be63c
JS
837 # create the link, or replace it if it is out of date
838 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
839 }
840
26a07309
TR
841 # override all git executables in TEST_DIRECTORY/..
842 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
843 mkdir -p "$GIT_VALGRIND"/bin
503e2241 844 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
26a07309
TR
845 do
846 make_valgrind_symlink $file
847 done
848 # special-case the mergetools loadables
849 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
850 OLDIFS=$IFS
851 IFS=:
852 for path in $PATH
853 do
854 ls "$path"/git-* 2> /dev/null |
855 while read file
ad0e6233 856 do
26a07309 857 make_valgrind_symlink "$file"
ad0e6233 858 done
26a07309
TR
859 done
860 IFS=$OLDIFS
4e1be63c
JS
861 PATH=$GIT_VALGRIND/bin:$PATH
862 GIT_EXEC_PATH=$GIT_VALGRIND/bin
863 export GIT_VALGRIND
952af351
TR
864 GIT_VALGRIND_MODE="$valgrind"
865 export GIT_VALGRIND_MODE
5dfc368f 866 GIT_VALGRIND_ENABLED=t
26a07309 867 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 868 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
869elif test -n "$GIT_TEST_INSTALLED"
870then
e4597aae
MO
871 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
872 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 873 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
874 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
875else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 876 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
877 if ! test -x "$git_bin_dir/git"
878 then
879 if test -z "$with_dashes"
880 then
e4597aae
MO
881 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
882 fi
883 with_dashes=t
884 fi
885 PATH="$git_bin_dir:$PATH"
6cec5c68 886 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
887 if test -n "$with_dashes"
888 then
6cec5c68 889 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 890 fi
4e1be63c 891fi
6cec5c68 892GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 893GIT_CONFIG_NOSYSTEM=1
3c995beb 894GIT_ATTR_NOSYSTEM=1
8f323c00 895export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 896
5e87eae9
JH
897if test -z "$GIT_TEST_CMP"
898then
899 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
900 then
901 GIT_TEST_CMP="$DIFF -c"
902 else
903 GIT_TEST_CMP="$DIFF -u"
904 fi
905fi
906
6cec5c68 907GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 908export GITPERLLIB
6cec5c68 909test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
910 error "You haven't built things yet, have you?"
911}
e1970ce4 912
e6e7530d 913if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime
1c0cc756 914then
56cf9806 915 echo >&2 'You need to build test-chmtime:'
e6e7530d 916 echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
56cf9806
EW
917 exit 1
918fi
919
e1970ce4 920# Test repository
002d4ce8
JK
921TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
922test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
923case "$TRASH_DIRECTORY" in
924/*) ;; # absolute path is good
925 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 926esac
91c8b825 927test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 928rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 929 GIT_EXIT_OK=t
8d14ac94
JH
930 echo >&5 "FATAL: Cannot prepare test area"
931 exit 1
932}
933
90cff968 934HOME="$TRASH_DIRECTORY"
0ea47f9d
JH
935GNUPGHOME="$HOME/gnupg-home-not-used"
936export HOME GNUPGHOME
90cff968 937
1c0cc756
RJ
938if test -z "$TEST_NO_CREATE_REPO"
939then
38b074de 940 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 941else
38b074de 942 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 943fi
1bd9c648
LW
944# Use -P to resolve symlinks in our working directory so that the cwd
945# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 946cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 947
d5d9de1b
JS
948this_test=${0##*/}
949this_test=${this_test%%-*}
e6a6ddc9
TR
950if match_pattern_list "$this_test" $GIT_SKIP_TESTS
951then
952 say_color info >&3 "skipping test $this_test altogether"
953 skip_all="skip all tests in $this_test"
954 test_done
955fi
f17e9fbb 956
8648732e
BC
957# Provide an implementation of the 'yes' utility
958yes () {
959 if test $# = 0
960 then
961 y=y
962 else
963 y="$*"
964 fi
965
6129c930
JS
966 i=0
967 while test $i -lt 99
8648732e 968 do
6129c930
JS
969 echo "$y"
970 i=$(($i+1))
8648732e
BC
971 done
972}
973
f17e9fbb 974# Fix some commands on Windows
d98b2c5f
JS
975uname_s=$(uname -s)
976case $uname_s in
f17e9fbb
JS
977*MINGW*)
978 # Windows has its own (incompatible) sort and find
979 sort () {
980 /usr/bin/sort "$@"
981 }
982 find () {
983 /usr/bin/find "$@"
984 }
5397ea31
JS
985 sum () {
986 md5sum "$@"
987 }
4114156a
JS
988 # git sees Windows-style pwd
989 pwd () {
990 builtin pwd -W
991 }
ee9fb68c 992 # no POSIX permissions
6fd1106a 993 # backslashes in pathspec are converted to '/'
fb9a2bea 994 # exec does not inherit the PID
a94114ad 995 test_set_prereq MINGW
5f4e02e5 996 test_set_prereq NATIVE_CRLF
a31d0665 997 test_set_prereq SED_STRIPS_CR
97669eed 998 test_set_prereq GREP_STRIPS_CR
4d715ac0 999 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
1000 ;;
1001*CYGWIN*)
1002 test_set_prereq POSIXPERM
a31d0665 1003 test_set_prereq EXECKEEPSPID
cfa96496 1004 test_set_prereq CYGWIN
a31d0665 1005 test_set_prereq SED_STRIPS_CR
97669eed 1006 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
1007 ;;
1008*)
1009 test_set_prereq POSIXPERM
6fd1106a 1010 test_set_prereq BSLASHPSPEC
fb9a2bea 1011 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
1012 ;;
1013esac
704a3143 1014
b082687c 1015( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 1016test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 1017test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 1018test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 1019test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 1020
bb946bba 1021# Can we rely on git's output in the C locale?
30955229
JN
1022if test -n "$GETTEXT_POISON"
1023then
1024 GIT_GETTEXT_POISON=YesPlease
1025 export GIT_GETTEXT_POISON
5e9637c6 1026 test_set_prereq GETTEXT_POISON
30955229
JN
1027else
1028 test_set_prereq C_LOCALE_OUTPUT
1029fi
bb946bba 1030
cabdee2c
JH
1031# Use this instead of test_cmp to compare files that contain expected and
1032# actual output from git commands that can be translated. When running
1033# under GETTEXT_POISON this pretends that the command produced expected
1034# results.
1035test_i18ncmp () {
1036 test -n "$GETTEXT_POISON" || test_cmp "$@"
1037}
1038
127df8c6
JH
1039# Use this instead of "grep expected-string actual" to see if the
1040# output from a git command that can be translated either contains an
1041# expected string, or does not contain an unwanted one. When running
1042# under GETTEXT_POISON this pretends that the command produced expected
1043# results.
1044test_i18ngrep () {
1045 if test -n "$GETTEXT_POISON"
1046 then
1047 : # pretend success
1048 elif test "x!" = "x$1"
1049 then
1050 shift
1051 ! grep "$@"
1052 else
1053 grep "$@"
1054 fi
1055}
1056
20073274
AS
1057test_lazy_prereq PIPE '
1058 # test whether the filesystem supports FIFOs
9443605b 1059 case $(uname -s) in
a1f32964 1060 CYGWIN*|MINGW*)
9443605b
ML
1061 false
1062 ;;
1063 *)
1064 rm -f testfifo && mkfifo testfifo
1065 ;;
1066 esac
20073274
AS
1067'
1068
04083f27
JH
1069test_lazy_prereq SYMLINKS '
1070 # test whether the filesystem supports symbolic links
1071 ln -s x y && test -h y
1072'
c91cfd19 1073
b018c735
JN
1074test_lazy_prereq FILEMODE '
1075 test "$(git config --bool core.filemode)" = true
1076'
1077
ac39aa61
MG
1078test_lazy_prereq CASE_INSENSITIVE_FS '
1079 echo good >CamelCase &&
1080 echo bad >camelcase &&
1081 test "$(cat CamelCase)" != good
1082'
1083
5b0b5dd4
MG
1084test_lazy_prereq UTF8_NFD_TO_NFC '
1085 # check whether FS converts nfd unicode to nfc
1086 auml=$(printf "\303\244")
1087 aumlcdiar=$(printf "\141\314\210")
1088 >"$auml" &&
1089 case "$(echo *)" in
1090 "$aumlcdiar")
1091 true ;;
1092 *)
1093 false ;;
1094 esac
1095'
1096
09feffb6
JK
1097test_lazy_prereq AUTOIDENT '
1098 sane_unset GIT_AUTHOR_NAME &&
1099 sane_unset GIT_AUTHOR_EMAIL &&
1100 git var GIT_AUTHOR_IDENT
1101'
1102
6219bb22
JH
1103test_lazy_prereq EXPENSIVE '
1104 test -n "$GIT_TEST_LONG"
1105'
1106
e1ecd9e3
JH
1107test_lazy_prereq USR_BIN_TIME '
1108 test -x /usr/bin/time
1109'
1110
1767c517
JK
1111test_lazy_prereq NOT_ROOT '
1112 uid=$(id -u) &&
1113 test "$uid" != 0
1114'
1115
63b747ce
JT
1116test_lazy_prereq JGIT '
1117 type jgit
1118'
1119
719c3da2
JH
1120# SANITY is about "can you correctly predict what the filesystem would
1121# do by only looking at the permission bits of the files and
1122# directories?" A typical example of !SANITY is running the test
1123# suite as root, where a test may expect "chmod -r file && cat file"
1124# to fail because file is supposed to be unreadable after a successful
1125# chmod. In an environment (i.e. combination of what filesystem is
1126# being used and who is running the tests) that lacks SANITY, you may
1127# be able to delete or create a file when the containing directory
1128# doesn't have write permissions, or access a file even if the
1129# containing directory doesn't have read or execute permissions.
1130
f400e51c
TB
1131test_lazy_prereq SANITY '
1132 mkdir SANETESTD.1 SANETESTD.2 &&
1133
1134 chmod +w SANETESTD.1 SANETESTD.2 &&
1135 >SANETESTD.1/x 2>SANETESTD.2/x &&
1136 chmod -w SANETESTD.1 &&
719c3da2 1137 chmod -r SANETESTD.1/x &&
f400e51c
TB
1138 chmod -rx SANETESTD.2 ||
1139 error "bug in test sript: cannot prepare SANETESTD"
1140
719c3da2 1141 ! test -r SANETESTD.1/x &&
f400e51c
TB
1142 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1143 status=$?
1144
1145 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1146 rm -rf SANETESTD.1 SANETESTD.2 ||
1147 error "bug in test sript: cannot clean SANETESTD"
1148 return $status
1149'
f838ce58 1150
d98b2c5f 1151test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
f838ce58
JK
1152GIT_UNZIP=${GIT_UNZIP:-unzip}
1153test_lazy_prereq UNZIP '
1154 "$GIT_UNZIP" -v
1155 test $? -ne 127
1156'
9a308de3
JK
1157
1158run_with_limited_cmdline () {
1159 (ulimit -s 128 && "$@")
1160}
1161
1162test_lazy_prereq CMDLINE_LIMIT 'run_with_limited_cmdline true'
6b9c38e1
JK
1163
1164build_option () {
1165 git version --build-options |
1166 sed -ne "s/^$1: //p"
1167}
1168
1169test_lazy_prereq LONG_IS_64BIT '
1170 test 8 -le "$(build_option sizeof-long)"
1171'